﻿using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace XamGridProb
{
    /// <summary>
    /// Interaktionslogik für zumControl.xaml
    /// </summary>
    public partial class zumControl : UserControl
    {

        #region Dependency Properties
        public static readonly DependencyProperty zumFilterObjectProperty =
            DependencyProperty.Register("zumFilterObject", typeof(zumFilterObject), typeof(zumControl), new PropertyMetadata(null));
        #endregion Dependency Properties

        #region Fields
        private ICommand _addConditionButtonCommand;
        private ICommand _deleteConditionButtonCommand;
        #endregion Fields

        #region Properties
        public zumFilterObject zumFilterObject
        {
            get { return (zumFilterObject)GetValue(zumFilterObjectProperty); }
            set { SetValue(zumFilterObjectProperty, value); }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        #region PropertiesCommands
        public ICommand DeleteConditionButtonCommand
        {
            get { return _deleteConditionButtonCommand; }
            set
            {
                _deleteConditionButtonCommand = value;
                OnPropertyChanged("DeleteConditionButtonCommand");
            }
        }

        public ICommand AddConditionButtonCommand
        {
            get { return _addConditionButtonCommand; }
            set
            {
                _addConditionButtonCommand = value;
                OnPropertyChanged("AddConditionButtonCommand");
            }
        }
        
        #endregion PropertiesCommands


        #endregion Properties

        #region Constructor
        public zumControl()
        {
            InitializeCommands();
            InitializeComponent();
        }



        #endregion Constructor

        #region Public Methods

        #endregion Public Methods

        #region Internal Methods
        #endregion Internal Methods

        #region Protected Methods
        #endregion Protected Methods

        #region Private Methods
        private void InitializeCommands()
        {
          
            AddConditionButtonCommand = new Command(AddConditionButton, "AddConditionButtonCommand");
            DeleteConditionButtonCommand = new Command(DeleteConditionButton, "DeleteConditionButtonCommand");
        }

        //private void DeleteConditionButtonExecute(object o)
        //{
        //    throw new NotImplementedException();
        //}

        private void DeleteConditionButton(object obj)
        {
            zumFilterObject.Activezum.DeleteCondition();
        }

        private void AddConditionButton(object conditionType)
        {
            zumFilterObject.Activezum.AddCondition();
        }

      

       

      


        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion Private Methods
    }


    public sealed class Command : ICommand
    {
        #region Dependency Properties
        #endregion Dependency Properties

        #region Fields
        private readonly Func<object, bool> _canExecute;
        private readonly Action<object> _execute;
        private bool _canExecuteCache = true;
        private bool _locked;
        #endregion Fields

        #region Properties
        public event EventHandler CanExecuteChanged;
        #endregion Properties

        #region Constructor
        public Command(Action<object> execute, string commandName)
            : this(null, execute, commandName)
        {
        }

        public Command(Func<object, bool> canExecute, Action<object> execute, string commandName)
        {
            if (execute == null) throw new ArgumentNullException("execute");

            _execute = execute;
            _canExecute = canExecute;
            _commandName = commandName;

        }
        #endregion Constructor

        #region Public Methods
        public bool CanExecute(object parameter)
        {
            lock (this)
            {
                if (_canExecute != null)
                {
                    bool temp = _canExecute(parameter);
                    if (_canExecuteCache != temp)
                        _canExecuteCache = temp;
                }
            }
            return _locked ? false : _canExecuteCache;
        }

        public void Execute(object parameter)
        {
            Application.Current.Dispatcher.Invoke(() => _execute(parameter));
        }

        public void RefreshCanExecute()
        {
            CallCanExecuteChanged();
        }

        public void LockCommand()
        {
            _locked = true;
        }

        public void ReleaseCommand()
        {
            _locked = false;
        }
        #endregion Public Methods

        #region Internal Methods
        #endregion Internal Methods

        #region Protected Methods
        #endregion Protected Methods

        #region Private Methods
        private void CallCanExecuteChanged()
        {
            if (CanExecuteChanged != null)
                CanExecuteChanged(this, EventArgs.Empty);
        }
        #endregion Private Methods

        public string _commandName { get; set; }
    }
}
