﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace XamGridProb
{
    public class zumMultiValueColumnBase : EditableColumn
    {
        private MultiValueColumnContentProvider _provider;
     
        public Object Value
        {
            get { return GetValue(ValueProperty); }
            set { SetValue(ValueProperty, value); }
        }
     

        public static readonly DependencyProperty ValueProperty =
            DependencyProperty.Register("Value", typeof(Object), typeof(zumMultiValueColumnBase), new PropertyMetadata(null));


        protected override ColumnContentProviderBase GenerateContentProvider()
        {

            return _provider ?? (_provider = new MultiValueColumnContentProvider());
        }
    }

    public class MultiValueColumnContentProvider : ColumnContentProviderBase
    {
        private TextBox _editor;
        //private Boolean _isInitialized;

        public MultiValueColumnContentProvider()
        {
            //_editor = new TextBox();
        }
        public override FrameworkElement ResolveDisplayElement(Cell cell, Binding cellBinding)
        {
            if (cell != null)
            {
                _editor = new TextBox();
                var selectedItemBinding = new Binding
                {
                    Source = cell.Row.Data,
                    Path = new PropertyPath(cell.Column.Key),
                    //Mode = BindingMode.TwoWay,
                    //UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged
                };
                _editor.SetBinding(TextBox.TextProperty, selectedItemBinding);

                
            }
            return _editor;
        }

        protected override FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, Binding editorBinding)
        {
            var selectedItemBinding = new Binding
            {
                Source = cell.Row.Data,
                Path = new PropertyPath(cell.Column.Key),
                Mode = BindingMode.TwoWay,
                UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged
            };
            TextBox tb = new TextBox();
            tb.SetBinding(TextBox.TextProperty, selectedItemBinding);
            return tb;
        }

        public override object ResolveValueFromEditor(Cell cell)
        {
            return cell.Value;
        }

    }
    
}
